import { Api } from './api';
import { Cache } from '@ztimson/utils';
import { Meta, Notification } from './core';
import { PathedEventEmitter } from './pathed-events';
export type User = Meta & {
    username: string;
    name: string;
    email: string;
    image: string;
    disabled?: boolean;
    groups: string[];
    notifications: Notification[];
    permissions: string[];
    notes: string;
    custom?: any;
    lastLogin?: number | null;
    totp?: false | 'app' | 'email' | 'phone';
};
export declare class Users extends PathedEventEmitter {
    private readonly api;
    cache: Cache<string, User>;
    constructor(api: Api | string);
    delete(username: string): Promise<void>;
    all(reload?: boolean): Promise<User[]>;
    read(username: string, reload?: boolean): Promise<User>;
    update(user: User): Promise<User>;
    uploadImage(username: string, file: File): import('@ztimson/utils').PromiseProgress<any>;
}
//# sourceMappingURL=users.d.ts.map